import com.wutka.dtd.*;
import java.util.*;
import java.io.*;
/**
 * DTDReader permet de lire un fichier dtd et de renvoyer la liste des balises <br>
 * qui y correspond
 */
public class DTDReader 
{
	public class DTDReaderException extends Exception
	{
	public DTDReaderException(String s){super(s);}
	public DTDReaderException(Exception e){super(e.getMessage());}
	}
 private ListeBalise _data;
   
   /**
    * renvoie la liste des balises correspondant au document dtd
    */
 public  ListeBalise  getData(){return _data;}
/**
 * Constructeur de la classe DTDReader
 */
public DTDReader()
   {
   _data=new ListeBalise();
}


static int giveType(DTDDecl decl)
{

if (decl.equals(DTDDecl.FIXED)) return 2;
if (decl.equals(DTDDecl.IMPLIED)) return 0;
if (decl.equals(DTDDecl.REQUIRED)) return 1;
return 0;
           
}
/**
 * Parse un document dtd specifier dans un fichier dont le nom est filename
 */
public synchronized void parseDTD(String filename) throws DTDReaderException
   {	DTDParser parser;
   DTD dtd;
  try{
   	 parser=new DTDParser(new File(filename));
         dtd=parser.parse(true);
         if (dtd.rootElement==null) throw new DTDReaderException("root element of the dtd can't be determined");
      //  dtd.write(new PrintWriter(System.out));
       }catch (Exception e){throw new DTDReaderException(e);}
      Vector v=dtd.items;
        for (int i=0;i<v.size();i++)
       {
 	   if (v.get(i).getClass().getName().equals("com.wutka.dtd.DTDElement"))
 	   {
 		DTDElement atl=(DTDElement)v.get(i);
 		//System.out.println("ELEMENT"+atl.name +"\n");
		Balise b=new Balise(atl.name,atl.getContent().getClass().getName().equals("com.wutka.dtd.DTDEmpty"));
     		  for (Enumeration e = atl.attributes.keys() ; e.hasMoreElements() ;) 
     		  {
                  Object obj=e.nextElement();
                  String str=new String(obj.toString());
                  DTDAttribute dtdattribut=(DTDAttribute) atl.attributes.get(obj);
                //  System.out.println(dtdattribut.type.getClass());
                  AttributDecl attr;
                  if (dtdattribut.type.getClass().getName().equals("com.wutka.dtd.DTDEnumeration"))
                  {
                 // System.out.println("UNE ENUMERATION");
                  DTDEnumeration enum=(DTDEnumeration) dtdattribut.type;
                //  System.out.println(enum.getItemsVec());
          
          	String[] strtab=enum.getItem();
          	//System.out.println("strtab"+strtab);
          	Vector a=new Vector(10,10);
          	for (int ij=0;ij<strtab.length;ij++)
          	a.add(new String(strtab[ij]));
          	if (dtdattribut.decl==null) throw new DTDReaderException("erreur de lecture de la dtd sur l'element"+ atl.name);
          	attr=new AttributDecl(str,giveType(dtdattribut.decl),dtdattribut.defaultValue ,dtdattribut.defaultValue==null?new String(""):dtdattribut.defaultValue,dtdattribut.decl.toString(),a);
      
                }
                else
		{
                  
                  
                   attr=new AttributDecl(str,giveType(dtdattribut.decl),dtdattribut.defaultValue ,dtdattribut.defaultValue==null?new String(""):dtdattribut.defaultValue,dtdattribut.decl.toString());
                }
                  b.Add(attr);
                }
                b.setOrder(i);
                _data.add(b);
           }

      }
   

   }

/**
 * fonction de test
 */
public static void main(String [] args) throws Exception
{
/*System.out.println(args[0]);
new DTDReader().parseDTD(args[0]);*/
DTDParser parser=new DTDParser(new File(args[0]));
DTD dtd=parser.parse(true);
dtd.rootElement.write(new PrintWriter(System.out,true));
}
}
