import com.wutka.dtd.*;
import java.util.*;
import java.io.*;
public class DTDTree
{
	private Vector _dtdNodeElement;
	public IsSuperieurClass _superieur;
	public class IsSuperieurClass
	{
		class ImmediatementSuperieur
		{
		private String _name ;
		private String _superieur;
		public ImmediatementSuperieur(String name,String superieur)
		{
		_name=new String(name);
		_superieur=new String(superieur);
	}
		public String getName(){return _name;}
		public String getSuperieur(){return _superieur;}
		public String toString(){return new String("("+_name+","+_superieur+")");}
	}
	Vector _superieur;
	public IsSuperieurClass(){_superieur=new Vector(10,10);}
	public void addSuperieur(String name,String superieur){
		_superieur.add(new ImmediatementSuperieur(name,superieur));}
	public String getSuperieur(String name)
	{
	int taille=_superieur.size();
	ImmediatementSuperieur sup;
	for (int i=0;i<taille;i++)
	{
	sup=(ImmediatementSuperieur)_superieur.get(i);
	if (sup.getName().equals(name)) return sup.getSuperieur();
	}
	return null;
}
	public String toString()
	{
	String result=new String ("[");
	for (int i=0;i<_superieur.size();i++)
	result=new String(result+((ImmediatementSuperieur)_superieur.get(i)).toString());
	return new String(result+"]");
	}
	}
	class DTDNodeElement
	{
	private int type ; // sequence=1
			   // choice=2
			   // etoile=3
			   // plus=4
			   // pcdata=5
			   // element=6
			   // any=7
			   // mixed=8
			   // END=9
	private DTDNodeElement _fils1;
	private DTDNodeElement _fils2;
	private String _name;
	public boolean exist(String s)
	{
	if (type==1) {return (_fils1.exist(s)|| _fils2.exist(s));}
	if (type==2) {return (_fils1.exist(s)|| _fils2.exist(s));}
	if (type==5) {return false;}
	if (type==6) {return _name.equals(s);}
	if (type==7) {return false;}
	if (type==8) { return (_fils1.exist(s)|| _fils2.exist(s));}
	return false;
	}
	public void print(PrintWriter writer)
	{
	if (type==1) {writer.print("Seq(");_fils1.print(writer);
		      writer.print(",");
		      _fils2.print(writer);
		      writer.println(")");
		      writer.flush();
		return;
		}
	if (type==2) {writer.print("Choice(");
		      _fils1.print(writer);
		      writer.print(",");
		      _fils2.print(writer);
		      writer.print(")");
		      writer.flush();
		      return;
		}
	if (type==5) {writer.print("PCDATA");writer.flush();return;}
	if (type==6) {writer.print("Element("+_name+")");writer.flush();return;}
	if (type==7) {writer.print("ANY");writer.flush();return ;}
	if (type==8) {writer.print("Mixed(");
		      _fils1.print(writer);
		      writer.print(",");
		      _fils2.print(writer);
		      writer.print(")");
		      writer.flush();
		      return;
		}
}
public void getUnder(Vector result)
	{
	if (type==1) {_fils1.getUnder(result);
		     
		      _fils2.getUnder(result);
		     
		return;
		}
	if (type==2) {
		      _fils1.getUnder(result);
		      
		      _fils2.getUnder(result);
		     
		      return;
		}
	if (type==5) {return;}
	if (type==6) {
		result.add(_name);return;}
	if (type==7) {return ;}
	if (type==8) {_fils1.getUnder(result);
		      
		      _fils2.getUnder(result);
		      return;
		}
}

	public DTDNodeElement CreateFinish()
	{
	DTDNodeElement result=new DTDNodeElement();
	result.type=9;
	return result;
	}
	public DTDNodeElement CreateElement(String name)
	{
	DTDNodeElement result=new DTDNodeElement();
	result.type=6;result._name=new String(name);
	return result;
	}
	public DTDNodeElement CreatePCData()
	{
	DTDNodeElement result=new DTDNodeElement();
	result.type=5;
	return result;
	}
	public DTDNodeElement CreateChoice(DTDNodeElement choice1,DTDNodeElement choice2)
	{
	DTDNodeElement result=new DTDNodeElement();
	result._fils1=choice1;
	result._fils2=choice2;
	result.type=2;return result;
	}
	public DTDNodeElement CreateSequence(DTDNodeElement seq1,DTDNodeElement seq2)
	{
	DTDNodeElement result=new DTDNodeElement();
	result._fils1=seq1;
	result._fils2=seq2;
	result.type=1;return result;
}
public DTDNodeElement CreateMixed(DTDNodeElement seq1,DTDNodeElement seq2)
	{
	DTDNodeElement result=new DTDNodeElement();
	result._fils1=seq1;
	result._fils2=seq2;
	result.type=8;return result;
}
	public DTDNodeElement CreateAny(){
		DTDNodeElement result=new DTDNodeElement();
		result.type=7;
		return result;}
	public DTDNodeElement(){}
	public DTDNodeElement CreateDTDNode(DTDItem dtditem)
	{
	
	if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDPCData")) return CreatePCData();
	if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDAny")) return CreateAny();
	if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDName")) return CreateElement(((DTDName)dtditem).getValue());
	if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDSequence"))
	{
	DTDSequence dtdseq=(DTDSequence)dtditem;
	DTDItem [] dtditems=dtdseq.getItems() ;
	
	DTDNodeElement fils1=CreateDTDNode(dtditems[0]);
	dtdseq.remove(dtditems[0]);
	DTDNodeElement fils2;
	if (dtdseq.getItemsVec().size()!=0) fils2=CreateDTDNode(dtdseq);
			 else fils2=CreateFinish();
	return CreateSequence(fils1,fils2);
	}
	if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDChoice")) 
	{
	DTDChoice dtdseq=(DTDChoice)dtditem;
	DTDItem [] dtditems=dtdseq.getItems() ;
	
	DTDNodeElement fils1=CreateDTDNode(dtditems[0]);
	dtdseq.remove(dtditems[0]);
	
	DTDNodeElement fils2;
	if (dtdseq.getItemsVec().size()!=0) fils2=CreateDTDNode(dtdseq);
			 else fils2=CreateFinish();
	return CreateChoice(fils1,fils2);
	
}
if (dtditem.getClass().getName().equals("com.wutka.dtd.DTDMixed")) 
	{
	DTDMixed dtdseq=(DTDMixed)dtditem;
	DTDItem [] dtditems=dtdseq.getItems() ;
	
	DTDNodeElement fils1=CreateDTDNode(dtditems[0]);
	dtdseq.remove(dtditems[0]);
	
	DTDNodeElement fils2;
	if (dtdseq.getItemsVec().size()!=0) fils2=CreateDTDNode(dtdseq);
			 else fils2=CreateFinish();
	return CreateMixed(fils1,fils2);
	
}



return null;
	}
	
	
	}
public class DTDNode
	{
	private DTDNodeElement _elementcontent;
	private String _elementname;
	public DTDNode(String s,DTDNodeElement element)
	{
	_elementcontent=element;
	_elementname=new String(s);
}
public String getName(){return _elementname;}
 	public int relation(DTDNode node) // 0 si aucun rapport 
 	{
 		if (_elementcontent.exist(node._elementname)) return 1;
 		if (node._elementcontent.exist(_elementname)) return -1;
 		return 0;
 	}
public Vector getUnder()
{
Vector result=new Vector(10,10);
_elementcontent.getUnder(result);
return result;
}
}	
public DTDNode find(String s)
{
DTDNode result=null;
for (int i=0;i<_dtdNodeElement.size();i++)
{
if (((DTDNode)_dtdNodeElement.get(i)).getName().equals(s)) 
{
result=(DTDNode)_dtdNodeElement.get(i);
return result;
}
}
return result;
}
public String getSuperieur(String name)
{
return _superieur.getSuperieur(name);
}
public Vector getUnder(String s)
{
Vector result=null;
DTDNode node=find(s);
if (node!=null) result=node.getUnder();
return result;
}
public void InitSuperieur()
{
DTDNode result=null;
Vector name;
for (int i=0;i<_dtdNodeElement.size();i++)
{
result=(DTDNode)_dtdNodeElement.get(i);
name=result.getUnder();
for (int j=0;j<name.size();j++) _superieur.addSuperieur((String)name.get(j),result.getName());
}
}
public  synchronized void parseDTD(String filename) throws Exception
   {	DTDParser parser;
   DTD dtd;
   DTDNode mynode;
   _dtdNodeElement=new Vector();
   _superieur=new IsSuperieurClass();
   
  try{
   	 parser=new DTDParser(new File(filename));
         dtd=parser.parse();
      //  dtd.write(new PrintWriter(System.out));
       }catch (Exception e){throw e;}
      Vector v=dtd.items;
        for (int i=0;i<v.size();i++)
       {
 	   if (v.get(i).getClass().getName().equals("com.wutka.dtd.DTDElement"))
 	   {
 	   	DTDElement element=(DTDElement) v.get(i);
 	   	PrintWriter out=new PrintWriter(System.err);
 	   //	System.err.println(element.name);
 	   	
 	   	DTDItem item=element.content;
 	   	DTDNodeElement stub=new DTDNodeElement();
 	   	/*item.write(out);
 	   	out.flush();System.err.println("\n");*/
 	   	
 	   	DTDNodeElement test=stub.CreateDTDNode(item);
 	   	mynode=new DTDNode(element.name,test);
 	   	_dtdNodeElement.add(mynode);
 	   	/*test.print(out);
 	   		   	System.err.println("\n");
 	   		   	System.err.println("\n");*/
 	   }
 	}
 	InitSuperieur();
 	System.out.println(_superieur);
  }	
   
  public static void main(String [] args) throws Exception
  {
  DTDTree tree=new DTDTree();
  tree.parseDTD(args[0]);
  System.err.println(tree.getUnder(args[1]));
 
  }   	
	 
}