import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

/**
 * represente la visualisation graphique des tags du document 
 */
 
public class ListeTagIhm extends JScrollPane
{
class Couple
{
String _balise;
String _texte;
public String toString(){return new String("("+_balise+","+_texte+")");}
}
class MyCellRenderer extends JPanel implements ListCellRenderer {
      ImageIcon longIcon ;
     ImageIcon shortIcon ;
	JLabel un;
	JLabel deux;
	Font _font1;
	Font _font2;
     // This is the only method defined by ListCellRenderer.
     // We just reconfigure the JLabel each time we're called.
     public Font AttributeToFont(SimpleAttributeSet attr)
     {
     String font=StyleConstants.getFontFamily(attr);
     int size=StyleConstants.getFontSize(attr);
    boolean bold=StyleConstants.isBold(attr);
    boolean italic=StyleConstants.isItalic(attr);
    int style=(bold?Font.BOLD:0);
    if (italic) style=style+Font.ITALIC;
    Font result=new Font(font,style,size);
    
     return result;
     }
     public MyCellRenderer(SimpleAttributeSet font1,SimpleAttributeSet font2)
     {
     super(new FlowLayout(FlowLayout.LEFT,
          0,0));un=new JLabel(/*LEFT*/);
   	deux=new JLabel(/*LEFT*/);  
   	
        if (font1!=null && font2!=null){
_font1=AttributeToFont(font1);
_font2=AttributeToFont(font2);
un.setForeground(StyleConstants.getForeground(font1));
deux.setForeground(StyleConstants.getForeground(font2));
un.setBackground(StyleConstants.getBackground(font1));
deux.setBackground(StyleConstants.getBackground(font2));
System.out.println("construct font1"+_font1);
System.out.println("construct font2"+_font2);

          }
      	  setBackground(Color.white);
      	  setForeground(Color.black);
     longIcon = new ImageIcon("file_new.gif");
      shortIcon = new ImageIcon("file_save.gif");
  
   
   	}
     public Component getListCellRendererComponent(
       JList list,
       Object value,            // value to display
       int index,               // cell index
       boolean isSelected,      // is the cell selected
       boolean cellHasFocus)    // the list and the cell have the focus
     {
         Couple s=(Couple)value;
         
         un.setText(s._balise);
         if (_font1!=null) un.setFont(_font1);
         
         add(un);
         
         deux.setText(s._texte);
         if (_font2!=null) deux.setFont(_font2);
         add(deux);
     /*    System.out.println("font1"+_font1);
         System.out.println("font2"+_font2);
         System.out.println(value);*/
    
         return this;
     }
 }

/**
 * la fenetre mere
 */
protected MainFrame _master;
/**
 * la liste graphique 
 */
protected JList _liste;
/**
 * la liste des tag
 */
protected ListeTag _tag;
protected BaliseNode [] _bnode;
protected boolean _both ;
SimpleAttributeSet _mfont1;
SimpleAttributeSet _mfont2;
public void setBoth(boolean both) 
{
	_both=both;
getViewport().setView(_liste);

setVisible(true);
}
public void setFont1(SimpleAttributeSet font1){_mfont1=font1;}
public void setFont2(SimpleAttributeSet font2){_mfont2=font2;}
/**
 * constructeur de la classe , on passe la fenetre mere en parametre
 */
public ListeTagIhm(MainFrame master)
{
super(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	      JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
setSize(600, 400);
_master=master;
_liste=new JList();
getViewport().setView(_liste);
_both=true;
setVisible(true);
}


/**
 * mets a jour le composant avec une liste de tag
 */
public void SetTag(ListeTag tag,String document)
{
XmlNode xmlnode=new XmlNode();
xmlnode.Init(tag);
_bnode=xmlnode.getNode();

_liste=null;
_tag=tag;
Vector test=new Vector(10,10);
int decal=0;
BaliseNode work;
for (int i=0;i<_bnode.length;i++)
 {Couple couple=new Couple();
   String affiche=new String();
 	
 	work=_bnode[i];
 	if (work.IsDebut())
 	{
 	decal=decal+2;
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getDebutStringBalise();
 	int taille=work.getTag().getFin()-work.getTag().getDebut();
 	if (taille>20) taille=20;
 	/* TODO verifier la taille max */
 	couple._balise=new String(affiche);
 	couple._texte=(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	affiche=affiche+(document.substring(work.getTag().getDebut(),work.getTag().getDebut()+taille)).replace('\n',' ');
 	test.add(couple);
 	}
	else
	{decal=decal-2;
	if (_both){
	
 	for (int j=0;j<decal;j++) affiche=affiche+" ";
 	affiche=affiche+work.getTag().getFinStringBalise();
	couple._balise=new String(affiche);
	test.add(couple);}
}

}
_liste=new JList(test);
/*System.out.println("LISTETAGIHM font1"+_mfont1);
System.out.println("LISTETAGIHM font2"+_mfont2);*/

_liste.setCellRenderer(new MyCellRenderer(_mfont1,_mfont2));
getViewport().setView(_liste);
setVisible(true);

MouseListener mouseListener = new MouseAdapter() {
     public void mouseClicked(MouseEvent e) {
     try{  
             int index = _liste.locationToIndex(e.getPoint());
             if (!_both) index=index*2;
             Tag t;
             System.err.println(_bnode);
             if (_bnode[index].IsDebut()) t=_bnode[index].getTag();
             	else t=_bnode[index].getSoeur().getTag();
             System.out.println("Double clicked on Item " + index);
             ListeTagIhm.this._master.select(t);
             ListeTagIhm.this._master.viewLigne(t.getLigne());
     } catch (Exception ve) {System.out.println(ve);}; 
     }
 };
 _liste.addMouseListener(mouseListener);
 
repaint();
}
public void select (Tag t)
{
for (int i=0;i<_bnode.length;i++)
{
if (_bnode[i].getTag().equals(t)) {_liste.setSelectedIndex(i);
int max_ligne=_liste.getLastVisibleIndex();
JScrollBar _scroll=getVerticalScrollBar();
  if (_scroll==null) return;
  int max=_scroll.getMaximum();
  int nvalue=(i*max)/max_ligne;
  
  _scroll.setValue(nvalue);
return;}
}        
}

}
