

import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import org.xml.sax.SAXException;
import javax.swing.event.*;
import javax.swing.text.rtf.*;
import javax.swing.text.html.*;

/**
 * MainFrame represente la fenetre mere de l'application 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class MainFrame extends JFrame
{	
/**
 * la zone d'edition du texte
 */
protected  TextAreaPane _text1;
/** 
 * la fenetre d'edition des attribut
 */
protected CheckDialog _text2;
/**
 * la fenetre d'edition des styles de balises
 */
protected StyleEditBalise _text3;
/**
 * le repertoire courant ou se trouve les fichier
 */
protected File _directorie;

/**
 * la liste des tags (forme graphique)
 */
protected ListeTagIhm _text4;
protected DTDTree _dtdtree;
/**
 * la liste des balises 
 */
protected ListeBalise _listeBalise;
//protected ContextMenu _contextmenu;
/**
 * la barre d'outil 
 */
protected JToolBar _toolBar;
/**
 * le menu
 */
protected JMenuBar _menuBar;
/**
 * la liste des tags
 */
protected ListeTag _listetag;
/** 
 * la ligne de statut
 */
protected JLabel _status;
/**
 * le nom du fichier dtd
 */
protected String _dtdfile;
/**
 * le validateur de XML
 */
protected XmlValidator _validator;
/**
 * le lecteur et le validateur de DTD
 */
protected DTDValidator _dtdvalidator;
/**
 * panneau de separation 
 */
protected JSplitPane _split1;
/**
 * panneau de separation 
 */
protected JSplitPane _split2;
/**
 * panneau de separation 
 */
protected JSplitPane _split3;
/**
 * panneau de separation 
 */
protected JSplitPane _split4;
protected StyleButton _style_bouton;
protected JMenu mBalise;
protected JMenuItem _style_Item;
/**
 * boite de dialogue d'edition de preference
 */
protected TabbedPreference _pref;
public Vector GetDefaultColor(){return _text3.GetDefaultColor();}
public void initDefaultColorDialog(Vector v) {_text3.initDefaultColorDialog(v);}
public String getDTDFile(){return _dtdfile;}
public String getDefaultDirectorie(){return _directorie.getAbsolutePath();}
public void setDefaultDirectorie(String s)
{
try
{File f=new File(s);
if (f.isDirectory()) _directorie=f;
System.err.println("DIRECTORIE PAR DEFAULT CHANGER"+s);
}catch (Exception ee){System.err.println("SETDEFAULTDIRECTORUE   "+s+"n est pas valide");};
}

private String makeicon(String icon)
{
String result=new String("icons"+System.getProperty("file.separator")+icon);
return result;
}
private Action SaveFile()
{
ImageIcon iconOpen = new ImageIcon(makeicon("export.gif"));
Action toto = new AbstractAction("Export the document to Xml", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	SimpleFilter m_txtFilter=new SimpleFilter("xml","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION)
        	 {MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR)); return;}
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
		try {
                	 //_text1.load(fChoosen);
		 		FileWriter t=new FileWriter(fChoosen);
		 		PrintWriter pr=new PrintWriter(t,true);
		 		pr.print(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile));
		 		pr.close();
		 		t.close();
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();

	//System.out.println(GenerateXML.GenerateXML(_text1.getDocument(),_listetag));
	};

};
return (toto);


}


private Action Save()
{
ImageIcon iconOpen = new ImageIcon(makeicon("saveb.gif"));
Action toto = new AbstractAction("Save Balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{try{
	
	PrintWriter h=new PrintWriter(new FileOutputStream("test.xml"));
	
	h.close();
	
	SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
         	
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".sav");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.close();
           }
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action SaveDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_save.gif"));
Action toto = new AbstractAction("Save annoted document...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xmldoc");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());
          
           p.close();
           }
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action SaveDocument2()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_save.gif"));
Action toto = new AbstractAction("Save annoted document .", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	PrintWriter ostream = new PrintWriter(new FileOutputStream(fChoosen));
	
  	  /* p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());*/
        
          SaveXml.WriteDocument(ostream,_listetag,_listeBalise,_text1.getDocument(),_dtdfile);
          ostream.flush();
          ostream.close();
           /*p.close();*/
           }
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private Action Load()
{
ImageIcon iconOpen = new ImageIcon(makeicon("openb.gif"));
Action toto = new AbstractAction("Load balise ", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
          _text3.UpDate(_listeBalise);
			}
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
private void initStyleButton()
{
if (_style_bouton!=null) mBalise.remove(_style_Item);
_style_bouton=new StyleButton(_listeBalise,_toolBar,this);
_style_Item=new JMenuItem(_style_bouton.Save());
mBalise.add(_style_Item);

}
private Action quit()
{
Action toto=new AbstractAction("quit")
{
public void actionPerformed(ActionEvent e) {
	final JDialog myquit=new JDialog(MainFrame.this,"Quit",true);
	JPanel panel=new JPanel(new FlowLayout(FlowLayout.RIGHT));
	JButton save=new JButton("Save");
	 ActionListener hardquit = new ActionListener() 
	 { 
      public void actionPerformed(ActionEvent e) {
      	System.exit(0);
      	}
};
ActionListener hcancel = new ActionListener() { 
      public void actionPerformed(ActionEvent e) 
      {
      System.err.println("TOTO");
   myquit.setVisible(false);
    
      }
};
	JButton hquit=new JButton("Quit");
	hquit.addActionListener(hardquit);
	JButton cancel=new JButton("Cancel");
	save.addActionListener(SaveDocument2());
	JLabel label=new JLabel("You gonna to exit from XmlJava???");
	panel.add(label);
	panel.add(save);
	cancel.addActionListener(hcancel);
	panel.add(cancel);
	panel.add(hquit);
	
	myquit.getContentPane().add(panel);
	Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).5;
Point p=new Point((int)(width_screen*.2),(int)(height_screen*pourcent));
myquit.setLocation(p);
myquit.setSize((int)(width_screen*.5),(int)(height_screen*.2));
	myquit.setVisible(true);
	
	}
};
return toto;
}
private Action LoadDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_open.gif"));
Action toto = new AbstractAction("Load annoted document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION){
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         initStyleButton();
         _listetag=(ListeTag)p.readObject();
         _text1.setDocument(p.readUTF());
    
           
          _text3.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _text4.SetTag(_listetag,_text1.getDocument());
          	
			}
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action LoadDocument2()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_open.gif"));
Action toto = new AbstractAction("Load annoted document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xml","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) {
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();
	FileReader f=new FileReader(fChoosen);
	DefaultHandlerLoadXml _reader=new DefaultHandlerLoadXml();
         _reader.lect(f);
         
         _dtdfile=_reader.getDtdFileName();
         System.err.println(_dtdfile);
         System.err.println(_reader.getDocument());
          System.err.println(_dtdfile);
         _listeBalise=new ListeBalise();
         _listeBalise=_reader.getListeBalise();
         _listetag=_reader.getListeTag();
         _text1.setDocument(_reader.getDocument());
    
           
          _text3.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _text4.SetTag(_listetag,_text1.getDocument());
          initStyleButton();
          	_text1.initLoad();
		}	
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
public void repaint_mypanel()
{
_text1.repaintTag(_listetag);
_text3.UpDate(_listeBalise);
}
public void gereCollision(int x,int y)
{ _text3.ActivAll(!_listetag.recouvre(x,y));
 Tag _tag=_listetag.search(x,y);
 if (_tag!=null) 
 	{
 	Vector v=_dtdtree.getUnder(_tag.getBalise().getName());
 	if (v!=null) _text3.Activ(v);
 	}

 
}
public void setPlainTextAttr(MutableAttributeSet attr )
{
_text1.setPlainTextAttr(attr);

}
/**
 * met a jour les panneau avec un style de preferences
 * @param sa le style par preference
 */
public void setPreference(SimpleAttributeSet sa)
{
if (sa!=null) _listeBalise.setDefaultStyle(sa,true);

_text4.setBoth(!_pref.getBoth());

_text4.setFont1(_pref.getAttributesTagBody());
_text4.setFont2(_pref.getAttributesSampleText());
if (_text1!=null && _text1.getDocument()!=null ) _text4.SetTag(_listetag,_text1.getDocument());
_text1.repaintTag(_listetag);
_text3.UpDate(_listeBalise);
UpDateTag();
}
public Document getDocumentFromSwing()
{
return (_text1.getDocumentFromSwing());
}
private Action Preference()
{
ImageIcon iconOpen = new ImageIcon(makeicon("preference.gif"));
Action toto = new AbstractAction("Preference", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{ _pref.setVisible(true);
		
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

/** 
 * mets a jour la ligne de status 
 * @param status le statut a afficher
 */
public void setStatus(String status)
{
_status.setText(status);
_status.repaint();
}
/**
 * renvoie la liste des tags
 * @result la liste des tags
 *
 */
public ListeTag getTag(){return _listetag;}
private Action LoadFile()
{
ImageIcon iconOpen = new ImageIcon(makeicon("file_new.gif"));
Action toto = new AbstractAction("Load a text document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("txt","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION) 
            	{MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = m_chooser.getSelectedFile();
		try {
		 	_listetag=new ListeTag();
                	 _text1.load(fChoosen);
		 	
			_text4.SetTag(_listetag,_text1.getDocument());
		 
			}
            	catch (Exception ex) {System.out.println(ex);}}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
private Action NewDocument()
{
ImageIcon iconOpen = new ImageIcon(makeicon("new_document.gif"));
Action toto = new AbstractAction("new document", iconOpen) 
{ 
	 public void actionPerformed(ActionEvent e) {
    
_listetag=new ListeTag();
_text1.setDocument(new String(""));
_text4.SetTag(_listetag,_text1.getDocument());
		}; 
	
};
return (toto);
}
public Action ExportHTML()
{
ImageIcon iconOpen = new ImageIcon(makeicon("html.gif"));
 Action toto = new AbstractAction("Export to html...", iconOpen) 
 {
      public void actionPerformed(ActionEvent e) {
     HTMLEditorKit m_kit=new HTMLEditorKit();
     final JFileChooser m_chooser = new JFileChooser(); 
    	
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION)
      {
             File fChoosen = m_chooser.getSelectedFile();
	     try {  OutputStream out = new FileOutputStream(fChoosen);
	     Document m_doc=_text1.getDocumentFromSwing();
              m_kit.write(out, m_doc, 0, m_doc.getLength());
              out.close();
                 } 
            catch (Exception ex) {ex.printStackTrace();}
           
            
      };
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  };
  
      };
    
   return toto;
}

public Action ExportRTF()
{
ImageIcon iconOpen = new ImageIcon(makeicon("rtf.gif"));
 Action toto = new AbstractAction("Export to rtf...", iconOpen) 
 {
      public void actionPerformed(ActionEvent e) {
      RTFEditorKit m_kit=new RTFEditorKit();
     final JFileChooser m_chooser = new JFileChooser(); 
    	
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
      if (m_chooser.showSaveDialog(MainFrame.this) == JFileChooser.APPROVE_OPTION)
      {
             File fChoosen = m_chooser.getSelectedFile();
	     try {  OutputStream out = new FileOutputStream(fChoosen);
	     Document m_doc=_text1.getDocumentFromSwing();
              m_kit.write(out, m_doc, 0, m_doc.getLength());
              out.close();
                 } 
            catch (Exception ex) {ex.printStackTrace();}
           
            
      };
      MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
  };
  
      };
    
   return toto;
    }
public  String getDocument()
{
	String generate=GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile);
	return generate;
}
private Action ValidatorStrict()
{
ImageIcon iconOpen = new ImageIcon(makeicon("validS.gif"));
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),true);
	_validator.setVisible(true);
	}
};
return (toto);
}
private Action Validator()
{
ImageIcon iconOpen = new ImageIcon(makeicon("valid.gif"));
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),false);
	_validator.setVisible(true);
	}
};
return (toto);
}

private Action LoadFileDTD()
{
ImageIcon iconOpen = new ImageIcon(makeicon("dtd_open.gif"));
Action toto = new AbstractAction("Load DTD File", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("dtd","DTD File");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION)
        	 {
        	 	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
      	return;
        	 }
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

		try {
			File fChoosen = m_chooser.getSelectedFile();
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(fChoosen.getPath());
			 System.out.println("_dtdFILE:"+fChoosen);
			 DReader.parseDTD(fChoosen.getAbsolutePath());
			 _dtdtree=new DTDTree();
			 _dtdtree.parseDTD(fChoosen.getAbsolutePath());
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesTagBody(),true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
                }
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
/**
 * LectDTD permet de lire un fichier de dtd
 * @param filename la dtd
 */
public void LectDTD(String filename)
{DTDReader DReader=null;
try {
			
			 DReader=new DTDReader();
			 
			_dtdfile=new String(filename);
			 System.out.println(filename);
			 DReader.parseDTD(filename);
			  _dtdtree=new DTDTree();
			 _dtdtree.parseDTD(filename);
			 System.out.println(DReader.getData());
		}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
               }
           if (DReader!=null)
           {    try {
               	
			 _listeBalise=DReader.getData();
			 SimpleAttributeSet defaultattr=_pref.getAttributesTagBody();
			 System.out.println("DEFAULT ATTR"+defaultattr);
			 _listeBalise.setDefaultStyle(defaultattr,true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
			initStyleButton();
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture des preference")+ex.toString());
                        _dtdvalidator.setVisible(true);
            }   }
}
/**
 * mets ajour la listes des tag pour le panneau d'edition
 */
public void UpDateTag()
{
_listetag.UpDateDocument(_text1);
}
/**
 * gere la selection d'un tag
 * @param t le tag selectionn
 */
public void select(Tag t)
{
System.out.println("select Tag t "+t.toString());
_text1.repaintTag(_listetag);
_text2.init(t.getBalise(),t);
_text2.getViewport().setVisible(true);
_text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
_text4.select(t);
}
/**
 * enleve un tag de la liste et met a jour les panneau 
 * @param tag le tag a enlever
 * @result vrai si ca c'est bien passer
 */
public boolean remove(Tag tag)
{
boolean result=_listetag.remove(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}
/**
 * enleve les tag de la liste entourant tag et met a jour les panneau 
 * @param tag le tag englobant
 * @result vrai si ca c'est bien passer
 */
public boolean removeGroup(Tag tag)
{
boolean result=_listetag.removeGroup(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}

/**
 * mets jour graphiquement les differentes fenetres avec une position dans le texte
 * @param pos la position dans le texte
 *
 */
public void UpDateChild(int pos,boolean select)
{
Tag t=_listetag.search(pos);
if (t!=null) 
{
	_text2.init(t.getBalise(),t);
	_text2.getViewport().setVisible(true);
	_text1.repaintTag(_listetag);
	if (select) _text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
        _text4.select(t);
}
	else 
	{
		_text2.getViewport().setVisible(false);
		_text1.repaintTag(_listetag);
	}
}
/**
 * mets a jour la liste des tags Ihm
 */
public void UpDateListe()
{
_text4.SetTag(_listetag,_text1.getDocument());
}
/**
 * defile les panneau pour voir la ligne ligne
 * @param ligne le numero de la ligne 
 */
public void viewLigne(int ligne)
{
System.err.println("ligne a scroller :"+ligne);
_text1.scroll(ligne);
}
/**
 * met a jour le style graphique d'une balise 
 * @param b la balise concerne
 * @param attrM le stylegraphique
 */
private boolean searchTagSup(Vector v,String supname)
{
int taille=v.size();
Tag t;
for (int i=0;i<taille;i++) 
{
t=(Tag)v.get(i);
if (t.getBalise().getName().equals(supname)) return true;
}
return false;
}
public void AddMyTag(Tag tag)
{
_listetag.add(tag);
Vector sup=_listetag.getSuperieurTag(tag);
System.err.println(sup);
String tagname=tag.getBalise().getName();
String supname=_dtdtree.getSuperieur(tagname);
if (sup==null || !searchTagSup(sup,supname) )
{
Balise b=_listeBalise.getBaliseByName(supname);
System.err.println("BALISE D ORDRE SUPERIEUR"+supname);
if (b!=null)
{	System.err.println("doSomething():"+b.getRule().doSomething());
	if (tag.getBalise().getRule().doSomething())
	{
		if (tag.getBalise().getRule().autourBalise())
		{
		Tag t=new Tag(b,tag.getDebut(),tag.getFin(),tag.getLigne());
		AddMyTag(t);
		} 
		else if (tag.getBalise().getRule().autourParagraphe())
		{
		Element elem1=_text1.getParagraphe(tag.getDebut());
		Element elem2=_text1.getParagraphe(tag.getFin());
		if (elem1!=null && elem2!=null && elem1==elem2)
			{
			int debut=elem1.getStartOffset();
			int fin=elem1.getEndOffset();
			Tag t=new Tag(b,debut,fin,tag.getLigne());
			AddMyTag(t);
			}
		}
		else 
		if (tag.getBalise().getRule().autourDocument())
		{
			String str=_text1.getDocument();
			int taille=str.length();
			Tag t=new Tag(b,0,taille,0);
			AddMyTag(t);
		}
		else 
		if (tag.getBalise().getRule().autourRegExp())
		{
			String str=_text1.getDocument();
			int debut=tag.getDebut();
			int fin=tag.getFin();
			boolean order1=tag.getBalise().getRule().AvantDebut();
			boolean order2=tag.getBalise().getRule().AvantFin();
			String str1=tag.getBalise().getRule().RegExp1();
			String str2=tag.getBalise().getRule().RegExp2();
			
			int result1=SemantiqueRule.getBeginRegexp(str1,str,debut,order1);
			int result2=SemantiqueRule.getEndRegexp(str2,str,fin,order2);
			System.out.println("DEBUT:"+result1+"FIN:"+result2);
			if (result1!=-1 && result2!=-1){
			
			Tag t=new Tag(b,result1,result2,_text1.getLigne(result1));
			AddMyTag(t);}
		}
	
	}
}}

}
public void UpDateChild(Balise b,MutableAttributeSet attrM)
{
System.out.println("MainFrame::UpDateChild(Balise,MutableAttributSet");
Tag tag=new Tag(b,_text1.get_debut(),_text1.get_fin(),_text1.getLigne(_text1.get_debut()));

_text1.GereFin(_text1.get_fin());
AddMyTag(tag);
XmlNode test=new XmlNode();
test.Init(_listetag);
_listetag=test.toListeTag();
_text1.setListeTag(_listetag);
_text3.Activate(b);
_text2.init(b,tag);
UpDateChild((_text1.get_debut()+_text1.get_fin())/2,true);
new Thread()
{
public void run()
{
_text4.SetTag(_listetag,_text1.getDocument());
_text1.repaintTag(_listetag);
}
}.start();
//}
}
/**
 * Cree la bar de menu
 * @result la barre de menu cree
 */
public JMenuBar create_JMenuBar()
	{
	JMenuBar menuBar = new JMenuBar();
	JMenu mFile = new JMenu("File");
    mFile.setMnemonic('f');
	
	
 JMenuItem item =  mFile.add(LoadFile());
 item=mFile.add(NewDocument());
  //item=mFile.add(LoadDocument());
   item=mFile.add(LoadDocument2());
 //item=mFile.add(SaveDocument());
item=mFile.add(SaveDocument2());

 item=mFile.add(LoadFileDTD());
   item=mFile.add(SaveFile());
   mFile.add(ExportHTML());
   mFile.add(ExportRTF());
   mFile.add(new Printer(this));
   item=mFile.add(quit());
   mFile.add(item);
   
 JMenu mEdit = new JMenu("Edit");
    mEdit.setMnemonic('e');

    Action action = new AbstractAction("Copy", 
     new ImageIcon(makeicon("edit_copy.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.copy();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('c');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Cut", 
     new ImageIcon(makeicon("edit_cut.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.cut();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('t');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Paste", 
     new ImageIcon(makeicon("edit_paste.gif"))) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.paste();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('p');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
      KeyEvent.CTRL_MASK));
      
	_pref=new TabbedPreference(MainFrame.this);
	 mBalise = new JMenu("Balise");
	 mBalise.add(Save());
 	mBalise.add(Load());
	mEdit.add(Preference());
	if (_style_Item!=null && _style_bouton!=null){
	_style_Item=new JMenuItem(_style_bouton.Save());
	mBalise.add(_style_Item);}
   	menuBar.add(mFile);
   	menuBar.add(mEdit);
   	menuBar.add(mBalise);
   	
	menuBar.setVisible(true);
	return menuBar;
	}
/**
 * Cree la bar des boutons
 * @result la barre cree
 */
public JToolBar createToolBar()
{
 JToolBar m_toolBar = new JToolBar();
   JButton NewDoc=new SmallButton(NewDocument(),"New Document");
    JButton bOpen = new SmallButton(LoadFile(), "Load texte document ");
    JButton bOpenXML = new SmallButton(LoadDocument2(), "Load annoted document ");
    JButton bSaveXML = new SmallButton(SaveDocument2(), "Save annoted document");
   JButton rtf = new SmallButton(ExportRTF(), "export to RTF");
   JButton html = new SmallButton(ExportHTML(), "export to HTML");
  
   JButton print = new SmallButton(new Printer(this), "print document");
   
    JButton bOpenDTD = new SmallButton(LoadFileDTD(), "Load a DTD file");
   JButton validS=new SmallButton(ValidatorStrict(),"Valid document with DTD");
   JButton valid=new SmallButton(Validator(),"Valid quickly document");
    m_toolBar.add(NewDoc);
    m_toolBar.add(bOpen);
     m_toolBar.add(bOpenXML);
      m_toolBar.add(bSaveXML);
      m_toolBar.addSeparator();
     m_toolBar.add(bOpenDTD);
          m_toolBar.add(rtf);     m_toolBar.add(html);
     m_toolBar.add(print);
    m_toolBar.addSeparator();
   m_toolBar.add(_status);
   	m_toolBar.add(validS);
	m_toolBar.add(valid);
   return (m_toolBar);
}
/**
 * met a jour la taille des panneaux
 */
protected void OnSize()
 {
 _split1.setDividerLocation(.5);
_split2.setDividerLocation(.75);
_split3.setDividerLocation(.75);
 }
/**
 * Constructeur de la fenetre
 */
 
public MainFrame()
{
super();
Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).1;
Point p=new Point((int)(width_screen*pourcent),(int)(height_screen*pourcent));
setLocation(p);
setSize((int)(width_screen*8*pourcent),(int)(height_screen*8*pourcent));
_directorie=new File(".");

_status=new JLabel();
_text1=new TextAreaPane(this);
_text2=new CheckDialog(this);
_text3=new StyleEditBalise(this);
_text4=new ListeTagIhm(this);
try
{ _split1=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text2,_text3);
  _split1.setDividerLocation(.5);

 _split2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text1,_text4);
 _split2.setDividerLocation(.75);

 _split3=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,_split2,_split1);
_split3.setDividerLocation(.75);

this.addWindowListener(new WindowAdapter()
		{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
		public void windowDeiconified(WindowEvent e) 
           
           	{
           	OnSize();
           	}
		public void windowOpened(WindowEvent e) 
		{
		OnSize();
		}
           
		}
);

_listetag=new ListeTag();
_validator=new XmlValidator(this);
_dtdvalidator=new DTDValidator(this);
_toolBar=createToolBar();

getContentPane().add(_split3, BorderLayout.CENTER);
getContentPane().add(_toolBar, BorderLayout.NORTH);
_menuBar=create_JMenuBar();
setJMenuBar(_menuBar);

setVisible(true);
}
catch (Exception e) {System.err.println(e);System.err.println("Erreur D'initialisation des splitting pane");System.exit(0);}
}

public void init()
{repaint();
OnSize();
repaint();
//_text3.GereDefault();	
try{
FileReader fr=new FileReader("xmljava2.conf");
	ReadPreference rf=new ReadPreference();
	rf.lect(fr);
	SimpleAttributeSet plaint=rf.getDefaultPlainText();
	SimpleAttributeSet tagb=rf.getDefaultTagBody();
	SimpleAttributeSet annot=rf.getDefaultAnnotedText();
	SimpleAttributeSet samplet=rf.getDefaultSampleText();
	
	if (plaint!=null) {_pref.setAttributesPlainText(plaint);
		setPlainTextAttr(plaint);}

	if (tagb!=null) _pref.setAttributesTagBody(tagb);
	if (annot!=null) _pref.setAttributesAnnotedText(annot);
	if (samplet!=null) _pref.setAttributesSampleText(samplet);
	
	_pref.setBoth(rf.getBoth());
	_text4.setBoth(rf.getBoth());
	if (rf.getDtdFileName()!=null) LectDTD(rf.getDtdFileName());
	try{
	String defaultworking=rf.getDefaultFolder();
	File f=new File(defaultworking);
	if (f.isDirectory()) _directorie=f;
	}catch (Exception ee){};
	Vector mcolor=rf.getColor();
	System.out.println(mcolor);
if (mcolor!=null) { initDefaultColorDialog(mcolor);_text3.UpDate(_listeBalise);}
fr.close();
}
catch (Exception e){System.out.println(e);};


}

 

public static void main(String [] args)
{
 try
{
SplashScreen splash = new SplashScreen();
splash.finalize();



(new MainFrame()).init();
} 
catch (java.lang.Throwable e){System.err.println(e);}


}
}
