import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Permet delire les preference 
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class ReadPreference  extends DefaultHandler 
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
private static final String preference="preference";
private static final String style="style";
private static final String target="target";
private static final String foreground="foreground";
private static final String background="background";
private static final String fontname="fontname";
private static final String fontsize="fontsize";
private static final String underline="underline";
private static final String bold="bold";
private static final String italic="italic";
private static final String strikethrough="strikethrough";
private static final String subscript="subscript";
private static final String superscript="superscript";
private static final String sampletext="sampletext";
private static final String plaintext="plaintext";
private static final String tagbody="tagbody";
private static final String annotedtext="annotedtext";
private static final String defaultdtdfile="DefaultDtd";
private static final String name="name";
private static final String both="both";
private static final String value="value";
private static final String defaultcolor="defaultcolor";
private static final String workingfolder="workingfolder";
private String _dtdfilename;
private String _directorie;
private SimpleAttributeSet attributplain;
private SimpleAttributeSet attributannoted;
private SimpleAttributeSet attributtabbody;
private SimpleAttributeSet attributsampletext;
Vector mycolor;
boolean _both;
public SimpleAttributeSet getDefaultPlainText() {return attributplain;}
public SimpleAttributeSet getDefaultAnnotedText() {return attributannoted;}
public SimpleAttributeSet getDefaultTagBody() {return attributtabbody;}
public SimpleAttributeSet getDefaultSampleText() {return attributsampletext;}
public SimpleAttributeSet TextToAttr(String s)
{
if (s.equals(sampletext)) return attributsampletext;
if (s.equals(annotedtext)) return attributannoted;
if (s.equals(tagbody)) return attributtabbody;
if (s.equals(plaintext)) return attributplain;
return null;

}
/**
 * @result le nom du fichier
 */
public Vector getColor(){return mycolor;}
public String getDtdFileName(){return _dtdfilename;}
public String getDefaultFolder() {return _directorie;}
public boolean getBoth(){return _both;}
/**
 * hook appele lors du debut de lecture du document
 */
public void startDocument() 
{
	mycolor=new Vector();
	attributplain=new SimpleAttributeSet();
	attributannoted=new SimpleAttributeSet();
	attributtabbody=new SimpleAttributeSet();
	attributsampletext=new SimpleAttributeSet();
}
/**
 * appele lors de la lecture du nom du fichier DTD
 * @param attr attribut de l'element XML
 */
public void lectDTD(Attributes attr)
{
_dtdfilename=new String(attr.getValue(name));
}
public void setBoth(Attributes att)
{
_both=(att.getValue(value)).equals("true");

}
public static void writeColor(PrintWriter out,Vector col)
{
int taille=col.size();
String cols;
for (int i=0;i<taille;i++)
{
out.write("<"+defaultcolor+" value=\"");
cols=new String("#"+Integer.toHexString(((Color)col.get(i)).getRGB()&16777215));
out.write(cols+"\"/>\n");
}
out.flush();
}
public static void writeAttr(PrintWriter out,String targe,SimpleAttributeSet attr)
{
out.write("<"+style+" "+target+"=\""+targe+"\" ");

String fonts=StyleConstants.getFontFamily(attr);
out.write(new String(fontname+"=\""+fonts+"\" "));
int sizei=StyleConstants.getFontSize(attr);
out.write(new String(fontsize+"=\""+sizei+"\" "));
String col=new String("#"+Integer.toHexString(StyleConstants.getForeground(attr).getRGB()&16777215));
out.write(new String(foreground+"=\""+col+"\" "));
col=new String("#"+Integer.toHexString(StyleConstants.getBackground(attr).getRGB()&16777215));
out.write(new String(background+"=\""+col+"\" "));
String at=new String(underline+"=\""+StyleConstants.isUnderline(attr)+"\" ");
out.write(at);
 at=new String(bold+"=\""+StyleConstants.isBold(attr)+"\" ");
out.write(at);
 at=new String(italic+"=\""+StyleConstants.isItalic(attr)+"\" ");
out.write(at);
 at=new String(superscript+"=\""+StyleConstants.isSuperscript(attr)+"\" ");
out.write(at);
 at=new String(subscript+"=\""+StyleConstants.isSubscript(attr)+"\" ");
out.write(at);
 at=new String(strikethrough+"=\""+StyleConstants.isStrikeThrough(attr)+"\" ");
out.write(at);
out.write("/>\n");
out.flush();


}
public static void writePreference(PrintWriter out,TabbedPreference pref)
{
out.write("<"+preference+">\n");

boolean both_attr=pref.getBoth();
 writeAttr(out,sampletext,pref.getAttributesSampleText());
 writeAttr(out,plaintext,pref.getAttributesPlainText());
 writeAttr(out,tagbody,pref.getAttributesTagBody());
 writeAttr(out,annotedtext,pref.getAttributesAnnotedText());
String dtd=pref.getDTDFile();
out.write(new String("<"+defaultdtdfile+" "+name+"=\""+dtd+"\"/>\n"));
out.write(new String("<"+both+" "+value+"=\""+both_attr+"\"/>\n"));
writeColor(out,pref.getColorDefault());
out.write("<"+workingfolder+" "+value+"=\""+pref.getDefaultDirectorie()+"\"/>\n");
out.write("</"+preference+">\n");
out.flush();



}
void createAttributStyleBalise(SimpleAttributeSet targetattr,Attributes att)
{
StyleConstants.setFontFamily(targetattr,att.getValue(fontname));
StyleConstants.setFontSize(targetattr,Integer.parseInt(att.getValue(fontsize)));
String strfore=att.getValue(foreground).substring(1) ;
Color col=new Color(Integer.parseInt(strfore,16));
if (!mycolor.contains(col)) mycolor.add(col);
StyleConstants.setForeground(targetattr,col);
String strback=att.getValue(background).substring(1) ;
 col=new Color(Integer.parseInt(strback,16));
if (!mycolor.contains(col)) mycolor.add(col);
 StyleConstants.setBackground(targetattr,col);
StyleConstants.setUnderline(targetattr,att.getValue(underline).equals("true"));
StyleConstants.setBold(targetattr,att.getValue(bold).equals("true"));
StyleConstants.setItalic(targetattr,att.getValue(italic).equals("true"));
StyleConstants.setSuperscript(targetattr,att.getValue(superscript).equals("true"));
StyleConstants.setSubscript(targetattr,att.getValue(subscript).equals("true"));
StyleConstants.setStrikeThrough(targetattr,att.getValue(strikethrough).equals("true"));
}


public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{

if (localName.equals(style))
{
	createAttributStyleBalise(TextToAttr(attributes.getValue(target)),attributes);
}else if (localName.equals(defaultdtdfile))
{
lectDTD(attributes);
}
else if (localName.equals(workingfolder))
{
_directorie=attributes.getValue(value);
}
else if (localName.equals(defaultcolor))
{
if (mycolor==null) mycolor=new Vector(10,10);
String strback=attributes.getValue(value).substring(1) ;
Color col=new Color(Integer.parseInt(strback,16));
if (!mycolor.contains(col)) mycolor.add(col);
}
else if (localName.equals(both))
{
setBoth(attributes);
}
}
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{

}

public ReadPreference()
{

}
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public static void main(String args[]) 
{
 try{ SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  DefaultHandler lo = new DefaultHandlerLoadXml();
parser.setContentHandler (lo);
     parser.parse(new InputSource(new FileReader(args[0])));
    }catch (Exception q) {System.err.println(q);}
     
}
           
}