import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;


public class TabbedPreference extends JDialog  implements WindowListener
{
	class FilePreference extends JPanel 
	{
	JLabel _workingfolder;
	JLabel _default_dtd;
	JLabel _default_style;
	JTextField _default_dtd_field;
	JTextField _workingfolder_field;
	JTextField _default_style_field;
	String dtdfile;
	public FilePreference()
	{
	super(new GridLayout(3,1));
	JPanel p=new JPanel(new GridLayout(1,2));
	
	_workingfolder=new JLabel("Working Folder");
	_default_dtd=new JLabel("Default DTD");
	_default_style=new JLabel("Default Style");
	_default_dtd_field=new JTextField();
	_workingfolder_field=new JTextField();
	_default_style_field=new JTextField();
	p.add(_workingfolder);
	p.add(_workingfolder_field);
	add(p);
	 p=new JPanel(new GridLayout(1,2));
	
	p.add(_default_dtd);
	p.add(_default_dtd_field);
	add(p);
	 p=new JPanel(new GridLayout(1,2));
	
	p.add(_default_style);
	p.add(_default_style_field);
	add(p);
	dtdfile=new String();
}
public String getDefaultDirectorie()
{String result=_workingfolder_field.getText();
if (result!=null) return result; else return "";
}
public void init(String s,String s1)
 {
 	System.out.println("TabbedPreference::init(String "+s+")");
 _default_dtd_field.setText(s);
 _workingfolder_field.setText(s1);
 }
};

	class StylePreference extends JPanel implements ActionListener
	{
	private JComboBox _type_de_text;
	private JComboBox m_backColor;
	private JComboBox m_frontColor;
	private OpenList _font_list;
  	private OpenList _font_size;
  	private JCheckBox m_chkBold;
  	private JCheckBox m_chkItalic;
  	private JCheckBox m_chkUnderline;
  	private JCheckBox m_chkStrikethrough;
  	private JCheckBox m_chkSubscript;
  	private JCheckBox m_chkSuperscript;
  	private JTextPane  m_preview;
  	private String selectedText;
  	private  SimpleAttributeSet PlainText;
  	private  SimpleAttributeSet AnnotedText;
  	private  SimpleAttributeSet TagBody;
  	private  SimpleAttributeSet SampleText;
	private String selection;
	private String [] choiceStyle;
	public SimpleAttributeSet getPlainText(){return PlainText;}
	public SimpleAttributeSet getDefault()
	{
	SimpleAttributeSet result=new SimpleAttributeSet();
	StyleConstants.setForeground(result, Color.black);
	StyleConstants.setBackground(result,Color.white);
	StyleConstants.setFontSize(result,12);
	return result;
	}
	public StylePreference()
	{
	super(new BorderLayout());
	
	
	JPanel center=new JPanel(new GridLayout(1,2,10,2));
	JPanel droite=new JPanel(new GridLayout(2,1,10,2));
	JPanel gauche=new JPanel(new GridLayout(2,1,10,2));
	center.setBorder(new TitledBorder(new EtchedBorder(), "Default Style"));
	//droite.setBorder(new TitledBorder(new EtchedBorder(), "Color&Effects"));
  	gauche.setBorder(new TitledBorder(new EtchedBorder(), "Fonts"));
  	
	JPanel select_attr=new JPanel(new GridLayout(3,2,10,2));
	select_attr.setBorder(new TitledBorder(new EtchedBorder(), "Effects"));
  	JPanel select_color=new JPanel(new GridLayout(2,2,10,2));
  	select_color.setBorder(new TitledBorder(new EtchedBorder(), "Colors"));
  	
	String [] m_font=GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		
  	String []  m_fontSizes = new  String[] {"8", "9", "10", "11", "12", "14",
      "16", "18", "20", "22", "24", "26", "28", "36", "48", "72"}; 
      	 choiceStyle=new String[] {"Plain Text","Annoted Text","Tag Body","Sample Text"};
      	selection=new String(choiceStyle[0]);
       m_chkBold = new JCheckBox("Bold");
   	  m_chkItalic = new JCheckBox("Italic");
    	  m_chkUnderline = new JCheckBox("Underline");
    	  m_chkStrikethrough = new JCheckBox("Strikeout");
    	  m_chkSubscript = new JCheckBox("Subscript");
    	  m_chkSuperscript = new JCheckBox("Superscript");
    	  select_attr.add(m_chkBold);
    	  select_attr.add(m_chkItalic);
    	  select_attr.add(m_chkUnderline);
    	  select_attr.add(m_chkStrikethrough);
    	  select_attr.add(m_chkSubscript);
    	  select_attr.add(m_chkSuperscript);
    	  
    	   select_color.add(new JLabel("Front Color:"));
    	   m_frontColor=new JComboBox(getDefaultColor());
    	      m_frontColor.setRenderer(new ColorComboRenderer());
    	   m_backColor=new JComboBox(getDefaultColor());
    	      m_backColor.setRenderer(new ColorComboRenderer());
    	   select_color.add(m_frontColor);
    	   select_color.add(new JLabel("Back Color:"));
    	   select_color.add(m_backColor);
    	   droite.add(select_attr);
    	   droite.add(select_color);
    	   _font_list=new OpenList(m_font, "Name:",2);
    	  _font_size=new OpenList(m_fontSizes,"Size",2);
    	  gauche.add(_font_size);
    	  gauche.add(_font_list);
    	  center.add(gauche);
    	  center.add(droite);
    	    m_preview = new JTextPane();
    	    m_preview.setEditorKit(new StyledEditorKit());
   	    m_preview.setDocument(new DefaultStyledDocument(new StyleContext()));
   	  setPreviewText("Plain Text");
    m_preview.setDoubleBuffered(true);
    m_preview.setEditable(false);
    m_preview.setBorder(new LineBorder(Color.black));
    m_preview.setPreferredSize(new Dimension(120, 40));
   	    _type_de_text=new JComboBox(choiceStyle);
   	   	
   	  
   	      _type_de_text.addActionListener(this);
   	    add(_type_de_text,BorderLayout.NORTH);
   	    add(center,BorderLayout.CENTER);
   	    add(m_preview,BorderLayout.SOUTH);
   	     ActionListener lst = new ActionListener() {
   	     	public void actionPerformed(ActionEvent e) {updatePreview();}
   	     	};
   	    ListSelectionListener lsel = new ListSelectionListener() {public void valueChanged(ListSelectionEvent e) {updatePreview();}};
   	      m_chkBold.addActionListener(lst);
    m_chkItalic.addActionListener(lst);
   m_backColor.addActionListener(lst);
     
       m_frontColor.addActionListener(lst);
       m_chkSubscript.addActionListener(lst);
       m_chkStrikethrough.addActionListener(lst);
       m_chkSuperscript.addActionListener(lst);
       m_chkUnderline.addActionListener(lst);
        _font_list.addListSelectionListener(lsel);
    	_font_size.addListSelectionListener(lsel);
 	SampleText=getDefault();
	 AnnotedText=getDefault();
	 TagBody=getDefault();
	System.err.println("ANNOTEDTEXT*************"+AnnotedText+"************");
	 PlainText=getDefault();
	 setAttributes(SampleText);
	 setAttributes(AnnotedText);
	 setAttributes(TagBody);
	 setAttributes(PlainText);
   	    pack();
   	    
	}
	public void UpDateData()
	{
	if (selection.equals(choiceStyle[0]))
   	   	{ System.out.println("cas 1 plaintext:"+PlainText);
   	   		PlainText=getAttributes();
   	   	}
   	   	else if (selection.equals(choiceStyle[1]))
   	   	{ System.out.println("cas 2 AnnotedText:"+AnnotedText);
   	   	 AnnotedText=getAttributes();}
   	   	else if (selection.equals(choiceStyle[2]))
   	   	{ System.out.println("cas 3 TagBody:"+TagBody);
   	   	TagBody=getAttributes();}
   	   	else 
   	   	{ System.out.println("cas 4 SampleText:"+SampleText);
   	   	
   	   	SampleText=getAttributes();
   	   	}
	}
private  SimpleAttributeSet TextToAttr(String s)
{
if (s.equals(choiceStyle[0])) return PlainText;
if (s.equals(choiceStyle[1])) return AnnotedText;
if (s.equals(choiceStyle[2])) return TagBody;
if (s.equals(choiceStyle[3])) return SampleText;
return null;
}
public void apply()
{
	   	System.err.println("SELECTION******:"+selection);
   	   	if (selection.equals(choiceStyle[0]))
   	   	{ 
   	   		PlainText=getAttributes();System.out.println("cas 1 plaintext:"+PlainText);
   	   	}
   	   	else if (selection.equals(choiceStyle[1]))
   	   	{ 
   	   	 AnnotedText=getAttributes();System.out.println("cas 2 AnnotedText:"+AnnotedText);}
   	   	else if (selection.equals(choiceStyle[2]))
   	   	{ 
   	   	TagBody=getAttributes();System.out.println("cas 3 TagBody:"+TagBody);}
   	   	else 
   	   	{
   	   	
   	   	SampleText=getAttributes(); System.out.println("cas 4 SampleText:"+SampleText);
   	}
   	
}
public void setVisible(boolean b)
{
super.setVisible(b);
setAttributes(TextToAttr(selection));
}
	public  void actionPerformed(ActionEvent e)
   	   	{
   	   	
   	   	String s=(String)_type_de_text.getSelectedItem();
   	   	System.out.println("On a changer de contexte");
   	   	System.out.println(s);
   
   	   	System.out.println("Selection avant"+selection);
   	   	/*if (s.equals(choiceStyle[0]))
   	   	{ System.out.println("cas 1 plaintext:"+PlainText);
   	   		 setAttributes(PlainText);
   	   		
   	   	}
   	   	else if (s.equals(choiceStyle[1]))
   	   	{ System.out.println("cas 2 AnnotedText:"+AnnotedText);
   	   	 setAttributes(AnnotedText);}
   	   	else if (s.equals(choiceStyle[2]))
   	   	{ System.out.println("cas 3 TagBody:"+TagBody);
   	   	 setAttributes(TagBody);}
   	   	else 
   	   	{ System.out.println("cas 4 SampleText:"+SampleText);
   	   	setAttributes(SampleText);}
   	   	System.err.println("Selection apres"+selection);*/
   	   	setAttributes(TextToAttr(s));
   	   	 selection=new String(s);	
   	   		
   	   	
   	};
public void setAttributesPlainText(SimpleAttributeSet a) {PlainText=a;}
public void setAttributesTagBody(SimpleAttributeSet a) {TagBody=a;}
public void setAttributesAnnotedText(SimpleAttributeSet a) {AnnotedText=a;}
public void setAttributesSampleText(SimpleAttributeSet a) {SampleText=a;}
public SimpleAttributeSet getAttributesPlainText() {return PlainText;}
public SimpleAttributeSet getAttributesTagBody() {return TagBody;}
public SimpleAttributeSet getAttributesAnnotedText() {return AnnotedText;}
public SimpleAttributeSet getAttributesSampleText() {return SampleText;}
 public void setAttributes(AttributeSet a) {
    if (a==null) return;
    String name = StyleConstants.getFontFamily(a);  
    _font_list.setSelected(name);
    _font_size.setSelected(new Integer(StyleConstants.getFontSize(a)).toString());
  m_chkBold.setSelected(StyleConstants.isBold(a));
    m_chkItalic.setSelected(StyleConstants.isItalic(a));
    m_chkUnderline.setSelected(StyleConstants.isUnderline(a));
      
 m_chkStrikethrough.setSelected(StyleConstants.isStrikeThrough(a));
 m_chkSubscript.setSelected(StyleConstants.isSubscript (a));
 m_chkSuperscript.setSelected(StyleConstants.isSuperscript(a));
  m_frontColor.setSelectedItem(StyleConstants.getForeground(a));
    m_backColor.setSelectedItem(StyleConstants.getBackground(a));
    
   
 
}


	
private Vector getDefaultColor()
	{Vector result=new Vector(10,10);
	  int[] values = new int[] { 0, 128, 192, 255 };
    for (int r=0; r<values.length; r++) 
    {
      for (int g=0; g<values.length; g++) 
      {
        for (int b=0; b<values.length; b++) 
        {
          Color c = new Color(values[r], values[g], values[b]);
          result.add(c);
        }
      }
    }
  return result;
	}
	public void setPreviewText(String filename)
	{
	  StyledDocument doc=m_preview.getStyledDocument();
           int taille=doc.getLength();
           try{ 
           	MutableAttributeSet attr=new SimpleAttributeSet();
           	 doc.remove(0, taille) ;
		doc.insertString(0,filename,attr);
	}catch (Exception h){System.out.println(h);}
}
public void setPreviewText(String filename,AttributeSet a)
	{
	  StyledDocument doc=m_preview.getStyledDocument();
           int taille=doc.getLength();
           try{ 
  
 doc.remove(0, taille) ;
		doc.insertString(0,filename,a);
	}catch (Exception h){System.out.println(h);}
}

	 public SimpleAttributeSet getAttributes() {
  
      SimpleAttributeSet result=new SimpleAttributeSet();
    StyleConstants.setFontFamily(result, 
      _font_list.getSelected());
    StyleConstants.setFontSize(result, 
      _font_size.getSelectedInt());
    StyleConstants.setBold(result, 
      m_chkBold.isSelected());
    StyleConstants.setItalic(result, 
      m_chkItalic.isSelected());
    StyleConstants.setUnderline(result, 
      m_chkUnderline.isSelected());
    StyleConstants.setStrikeThrough(result, 
      m_chkStrikethrough.isSelected());
    StyleConstants.setSubscript(result, 
      m_chkSubscript.isSelected());
    StyleConstants.setSuperscript(result, 
      m_chkSuperscript.isSelected());
    StyleConstants.setForeground(result, 
      (Color)m_frontColor.getSelectedItem());
   StyleConstants.setBackground(result,(Color)m_backColor.getSelectedItem());
    repaint();
    return result;
  }
   protected void updatePreview() {

 try
{  // System.out.println("updatePreview1");

      AttributeSet attr=getAttributes();
    setPreviewText("pilou",attr);
      
}
catch (Exception hg){System.out.println(hg);}
  }
}
class OptionPreference extends JPanel
	{
		private JCheckBox m_endingBalise;
		
		public OptionPreference()
		{
		super();
		m_endingBalise=new JCheckBox("Ending Balise");
		add(m_endingBalise);
		}	
	public JCheckBox getEndingBaliseOption(){return m_endingBalise;}
	}
  	
private JTabbedPane _tabbedPane;
private FilePreference _filepreference;
private StylePreference _stylepreference;
private OptionPreference _optionpreference;
private JPanel _panel;
private JButton save;
private JButton cancel;
private JButton ok;
private JButton apply;
private JScrollPane scrollpane;
private MainFrame _master;
private int x;
private int y;
private int width ;
private int height;
public boolean getBoth(){return _optionpreference.getEndingBaliseOption().isSelected();}
public void setBoth(boolean b){ _optionpreference.getEndingBaliseOption().setSelected(b);}
//public void setAttributes(AttributeSet a) {_stylepreference.setAttributes(a);}
public void setAttributesPlainText(SimpleAttributeSet a) {_stylepreference.setAttributesPlainText(a);}
public void setAttributesTagBody(SimpleAttributeSet a) {_stylepreference.setAttributesTagBody(a);}
public void setAttributesAnnotedText(SimpleAttributeSet a) {_stylepreference.setAttributesAnnotedText(a);}
public void setAttributesSampleText(SimpleAttributeSet a) {_stylepreference.setAttributesSampleText(a);}
public SimpleAttributeSet getAttributesPlainText(){return _stylepreference.getAttributesPlainText();}
public SimpleAttributeSet getAttributesTagBody(){return _stylepreference.getAttributesTagBody();}
public SimpleAttributeSet getAttributesAnnotedText(){return _stylepreference.getAttributesAnnotedText();}
public SimpleAttributeSet getAttributesSampleText(){return _stylepreference.getAttributesSampleText();}
public Vector getColorDefault(){return _master.GetDefaultColor();}
public String getDefaultDirectorie() {return _master.getDefaultDirectorie();}
public void makeit()
{  _stylepreference.apply();
   if (getAttributesAnnotedText()!=null) _master.setPreference(getAttributesAnnotedText());
  if (getAttributesPlainText()!=null) _master.setPlainTextAttr(getAttributesPlainText());
     
_master.setDefaultDirectorie(_filepreference.getDefaultDirectorie());
}
public TabbedPreference(MainFrame j)
{
super(j);

x=0;
y=0;
width=0;
y=0;
_master=j;
_panel=new JPanel(new BorderLayout());
JPanel panel=new JPanel(new FlowLayout(FlowLayout.RIGHT));
_tabbedPane=new JTabbedPane();
_filepreference=new FilePreference();
_stylepreference=new StylePreference();
_optionpreference=new OptionPreference();
_tabbedPane.addTab("File", _filepreference) ;
_tabbedPane.addTab("Font",_stylepreference);
_tabbedPane.addTab("Option",_optionpreference);
_panel.add(_tabbedPane,BorderLayout.CENTER);
cancel=new JButton("Cancel");
save=new JButton("Save");
ok=new JButton("ok");
apply=new JButton("Apply");
ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
         makeit();
         setVisible(false);
      }
    };
    ActionListener lst2 = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
         makeit();
        //setVisible(false);
      }
    };
     ActionListener lst3 = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
          
        setVisible(false);
      }
    };
    ActionListener lst4 = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        
        makeit();
         try
         {PrintWriter out=new PrintWriter(new FileWriter("xmljava2.conf"));
         ReadPreference.writePreference(out,TabbedPreference.this);
         out.flush();
         out.close();
         }catch (IOException ee){System.err.println(ee);}
        setVisible(false);
      }
    };
    apply.addActionListener(lst2);
    ok.addActionListener(lst);
     save.addActionListener(lst4);
  
    cancel.addActionListener(lst3);
panel.add(cancel);
panel.add(ok);
panel.add(apply);
panel.add(save);
_panel.add(panel,BorderLayout.SOUTH);
addWindowListener(this);
scrollpane=new JScrollPane(_panel);
getContentPane().add(scrollpane);
}
public void windowActivated(WindowEvent e){init();} 
public void windowClosed(WindowEvent e) { System.out.println("TabbedPane::windowClosed()");}
public void windowClosing(WindowEvent e) {System.out.println("TabbedPane::windowClosing()");}
public void windowDeactivated(WindowEvent e) {System.out.println("TabbedPane::windowDeactivated()");}
public void windowDeiconified(WindowEvent e) {System.out.println("TabbedPane::windowDeiconified()");}
public void windowIconified(WindowEvent e) {}
public void windowOpened(WindowEvent e)  {init();}
public String getDTDFile()
{
return _master.getDTDFile();
}

public void init()
 {
 System.out.println("TabbedPane::init()");
 _filepreference.init(_master.getDTDFile(),_master.getDefaultDirectorie());
 }

public void setVisible(boolean b)
{
if ( b==true)
{if (x==0 && y==0 && height==0 && width==0)
{
Dimension d=Toolkit.getDefaultToolkit().getScreenSize();
int height_screen=d.height;
int width_screen=d.width;
float pourcent=(float).1;
Point p=new Point((int)(width_screen*pourcent),(int)(height_screen*pourcent));
x=(int)(width_screen*pourcent);
y=(int)(height_screen*pourcent);
width=(int)(width_screen*8*pourcent);
height=(int)(height_screen*8*pourcent);
}
setLocation(new Point(x,y));
setSize(width,height);
}
if (b==false)
{
Dimension dim=getSize();
Point p=getLocation();
height=dim.height;
width=dim.width;
x=p.x;
y=p.y;
}
super.setVisible(b);
scrollpane.setVisible(b);

}

}